/*
 * File:   lcd_pic.c
 * Author:  Ing. Peter Adamec
 * Company: MCU Slovel s.r.o.
 * Contact: mcu@mcu.sk
 *
 * Created a long time ago in a galaxy far, far away.
 */

#include "lcd_pic.h"
#include <pic16f1508.h>

_delay_us(unsigned int delay)
{
volatile unsigned long temp;
for (temp=0;temp<delay;temp++) {}

}

_delay_ms(unsigned int delay)
{
volatile unsigned long temp;
while (delay)
    {
    for (temp=0;temp<333;temp++) ;
    delay--;
    }

}


void lcd_putstr (volatile char *string)
{
unsigned char temp=0;
while ((temp<disp_row) && (*(string+temp)!='\0') )
	{
	lcd_putchar(*(string+temp));
	temp++;
	}
}



/*
void lcd_lightoff (void)
{
light_PORT |= _BV(light);
}

void lcd_lighton(void)
{
light_PORT &= ~_BV(light);
}
*/
void lcd_putchar (uint8_t input)
{
uint8_t temp;
temp=input;

_setbit(LCD_RS,LCD_PORT_RS);	//LCD_PORT_RS |= _BV(LCD_RS);
_delay_us(1);
writeLCD(temp>>4);
writeLCD(input&0x0f);
_delay_us(1);
_clearbit(LCD_RS,LCD_PORT_RS);	//LCD_PORT_RS &= ~_BV(LCD_RS);
busy_dummy();
}

void lcd_init (void)
{
_io_out (DIR_D4,LCD_DIR_D4);		//LCD_DIR_D4  |= (_BV(LCD_D4));
_io_out (DIR_D5,LCD_DIR_D5);		//LCD_DIR_D5  |= (_BV(LCD_D5));
_io_out (DIR_D6,LCD_DIR_D6);		//LCD_DIR_D6  |= (_BV(LCD_D6));
_io_out (DIR_D7,LCD_DIR_D7);		//LCD_DIR_D7  |= (_BV(LCD_D7));
_io_out (DIR_RS,LCD_DIR_RS);		//LCD_DIR_RS  |= (_BV(LCD_RS));	
_io_out (DIR_RW,LCD_DIR_RW);		//LCD_DIR_RW  |= (_BV(LCD_RW));	
_io_out (DIR_E,LCD_DIR_E);			//LCD_DIR_E   |= (_BV(LCD_E));		
		
//light_DIR	|= (_BV(light));

_clearbit(LCD_D4,LCD_PORT_D4);	//LCD_PORT_D4  &= ~(_BV(LCD_D4));
_clearbit(LCD_D5,LCD_PORT_D5);	//LCD_PORT_D5  &= ~(_BV(LCD_D5));
_clearbit(LCD_D6,LCD_PORT_D6);	//LCD_PORT_D6  &= ~(_BV(LCD_D6));
_clearbit(LCD_D7,LCD_PORT_D7);	//LCD_PORT_D7  &= ~(_BV(LCD_D7));
_clearbit(LCD_RS,LCD_PORT_RS);	//LCD_PORT_RS  &= ~(_BV(LCD_RS));
_clearbit(LCD_RW,LCD_PORT_RW);	//LCD_PORT_RW  &= ~(_BV(LCD_RW));
_clearbit(LCD_E,LCD_PORT_E);	//LCD_PORT_E   &= ~(_BV(LCD_E));
//light_PORT	 |=  (_BV(light));


_delay_ms(30);
writeLCD(0x03); //init1 8bit interface
_delay_ms(10);
writeLCD(0x03); //init2 8bit interface
_delay_us(100);
writeLCD(0x03); //init3 8bit interface
_delay_us(100);

writeLCD(0x02); //4bit interface
busy_dummy();

writeLCD(0x02); //4bit interface -- function set
writeLCD(0x0c); //N =1 (2 lines) disp on
busy_dummy();

writeLCD(0x00); 
writeLCD(0x0c); //bit2 displej on bit1 cursor off bit0 blinking off
busy_dummy();

lcd_clear();

writeLCD(0x00); 
writeLCD(0x06); //increment on shift off
busy_dummy();

}

void busy_dummy (void)
{
uint8_t working, temp;

_io_in (DIR_D4,LCD_DIR_D4);		//LCD_DIR_D4  &= ~(_BV(LCD_D4));
_io_in (DIR_D5,LCD_DIR_D5);		//LCD_DIR_D5  &= ~(_BV(LCD_D5));
_io_in (DIR_D6,LCD_DIR_D6);		//LCD_DIR_D6  &= ~(_BV(LCD_D6));
_io_in (DIR_D7,LCD_DIR_D7);		//LCD_DIR_D7  &= ~(_BV(LCD_D7));
temp=0;
working=0;
_delay_us(10);
while ( (temp==0) && (working<=30)) 
	{
	_delay_us(4);
	/*
	_setbit(LCD_RW,LCD_PORT_RW);	//LCD_PORT_RW |= _BV(LCD_RW);
	_setbit(LCD_E,LCD_PORT_E);		//LCD_PORT_E |=  _BV(LCD_E);
	_delay_us(1);
	_clearbit(LCD_RW,LCD_PORT_RW);	//LCD_PORT_RW &= ~_BV(LCD_RW);
	_clearbit(LCD_E,LCD_PORT_E);	//LCD_PORT_E &= ~_BV(LCD_E);
	temp=LCD_PIN_D7&_BV(LCD_D7);

	_delay_us(1);
	_setbit(LCD_RW,LCD_PORT_RW);	//LCD_PORT_RW |= _BV(LCD_RW);
	_setbit(LCD_E,LCD_PORT_E);		//LCD_PORT_E |=  _BV(LCD_E);
	_delay_us(1);
	_clearbit(LCD_RW,LCD_PORT_RW);	//LCD_PORT_RW &= ~_BV(LCD_RW);
	_clearbit(LCD_E,LCD_PORT_E);	//LCD_PORT_E &= ~_BV(LCD_E);
	_delay_us(1); */
	working++;
	}
_io_out (DIR_D4,LCD_DIR_D4);		//LCD_DIR_D4  |= (_BV(LCD_D4));
_io_out (DIR_D5,LCD_DIR_D5);		//LCD_DIR_D5  |= (_BV(LCD_D5));
_io_out (DIR_D6,LCD_DIR_D6);		//LCD_DIR_D6  |= (_BV(LCD_D6));
_io_out (DIR_D7,LCD_DIR_D7);		//LCD_DIR_D7  |= (_BV(LCD_D7));
}

void lcd_clear(void)
{
writeLCD(0x00); 
writeLCD(0x01); //displej clear 
_delay_ms(5);
busy_dummy();
}

void writeLCD (uint8_t in) // d7 d6 d5 d4
{
uint8_t input;

input=in;
if ((input&0x01)!=0)
		{
		_setbit(LCD_D4,LCD_PORT_D4);	//LCD_PORT_D4 |= _BV(LCD_D4);
		}
	else
		{
		_clearbit(LCD_D4,LCD_PORT_D4);	//LCD_PORT_D4 &= ~_BV(LCD_D4);
		}
input=in;
if ((input&0x02)!=0)
		{
		_setbit(LCD_D5,LCD_PORT_D5);	//LCD_PORT_D5 |= _BV(LCD_D5);
		}
	else
		{
		_clearbit(LCD_D5,LCD_PORT_D5);	//LCD_PORT_D5 &= ~_BV(LCD_D5);
		}
input=in;
if ((input&0x04)!=0)
		{
		_setbit(LCD_D6,LCD_PORT_D6);	//LCD_PORT_D6 |= _BV(LCD_D6);
		}
	else
		{
		_clearbit(LCD_D6,LCD_PORT_D6);	//LCD_PORT_D6 &= ~_BV(LCD_D6);
		}
input=in;
if ((input&0x08)!=0)
		{
		_setbit(LCD_D7,LCD_PORT_D7);	//LCD_PORT_D7 |= _BV(LCD_D7);
		}
	else
		{
		_clearbit(LCD_D7,LCD_PORT_D7);	//LCD_PORT_D7 &= ~_BV(LCD_D7);
		}
_delay_us(1);
_setbit(LCD_E,LCD_PORT_E);		//LCD_PORT_E |= _BV(LCD_E);
_delay_us(20);
_clearbit(LCD_E,LCD_PORT_E);	//LCD_PORT_E &= ~_BV(LCD_E);
_delay_us(20);
	
}

void lcd_setposition (uint8_t riadok, uint8_t stlpec)
{
if (stlpec>0 && stlpec<40)
	{
	stlpec--;
	}
if (riadok==1)
	{
	lcd_setddram (riadok_1+stlpec);
	}
if (riadok==2)
	{
	lcd_setddram (riadok_2+stlpec);
	}
if (riadok==3)
	{
	lcd_setddram (riadok_3+stlpec);
	}
if (riadok==4)
	{
	lcd_setddram (riadok_4+stlpec);
	}
}


void lcd_setddram (uint8_t address)
{
uint8_t temp;

address |= 0x80;

temp=address;
_clearbit(LCD_RS,LCD_PORT_RS);	//LCD_PORT_RS &= ~_BV(LCD_RS);
_clearbit(LCD_RW,LCD_PORT_RW);	//LCD_PORT_RW &= ~_BV(LCD_RW);
_delay_us(1);
writeLCD(temp>>4);
writeLCD(address&0x0f);
_delay_us(1);
busy_dummy();
}
